package com.miqporta.cloc.cinemalocations;

import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.provider.MediaStore;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.util.TypedValue;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.amazonaws.SDKGlobalConfiguration;
import com.amazonaws.auth.CognitoCachingCredentialsProvider;
import com.amazonaws.mobileconnectors.s3.transferutility.TransferObserver;
import com.amazonaws.mobileconnectors.s3.transferutility.TransferUtility;
import com.amazonaws.regions.Region;
import com.amazonaws.regions.Regions;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3Client;
import com.amazonaws.services.s3.S3ClientOptions;
import com.amazonaws.services.s3.model.S3ObjectInputStream;
import com.amazonaws.util.IOUtils;

import com.karumi.dexter.Dexter;
import com.karumi.dexter.PermissionToken;
import com.karumi.dexter.listener.PermissionDeniedResponse;
import com.karumi.dexter.listener.PermissionGrantedResponse;
import com.karumi.dexter.listener.PermissionRequest;
import com.karumi.dexter.listener.single.PermissionListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.util.Calendar;


public class DetailActivity extends AppCompatActivity implements View.OnClickListener {

    private static String TAG = "CLOC:" +DetailActivity.class.getSimpleName();
    private static final int RESULT_LOAD_IMAGE = 1;

    EditText detalle_etTituloVO;
    EditText detalle_etTituloESP;
    EditText detalle_etAnyo;
    EditText detalle_etDirector;
    EditText detalle_etDescripcion;
    TextView detalle_labelDescripcion;
    LinearLayout linearLayout;
    String latitud;
    String longitud;
    Button botonAnadir;
    ImageView imagenSubir;

    boolean primeraDeOtrasImagen = true;
    String escenaIdGlobal;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_detail);
        Intent myIntent = getIntent();

        Bundle extras = getIntent().getExtras();
        if(extras == null){
            Log.i(TAG,"No hay parametros");
        }

        getSupportActionBar().setTitle(getResources().getString(R.string.title_activity_detail));

        detalle_etTituloVO = (EditText)findViewById(R.id.detalle_etTituloVO);
        detalle_etTituloESP = (EditText)findViewById(R.id.detalle_etTituloESP);
        detalle_etAnyo = (EditText)findViewById(R.id.detalle_etAnyo);
        detalle_etDirector = (EditText)findViewById(R.id.detalle_etDirector);
        botonAnadir = (Button) findViewById(R.id.detalle_botonAnyadir);
        botonAnadir.setOnClickListener(this);

        imagenSubir = (ImageView) findViewById(R.id.detalle_imagen_subir);
        imagenSubir.setOnClickListener(this);

        detalle_etDescripcion = (EditText) findViewById(R.id.detalle_etDescripcion);
        detalle_labelDescripcion = (TextView) findViewById(R.id.detalle_labelDescripcion);

        linearLayout = (LinearLayout) findViewById(R.id.layout_detail);

        //Recuperamos los datos de la anterior activity
        escenaIdGlobal = myIntent.getStringExtra("escenaId");
        latitud = myIntent.getStringExtra("latitud");
        longitud = myIntent.getStringExtra("longitud");

        //si ya existia se cargan los datos
        if(!"Nuevo".equals(escenaIdGlobal)) {
            String url = getResources().getString(R.string.conf_clocWs_dominio)
                    + getResources().getString(R.string.conf_clocWs_buscarPorEscena)
                    + escenaIdGlobal;
            new obtenerDetalleTask().execute(url);
            detalle_etDescripcion.setVisibility(View.GONE);
            detalle_labelDescripcion.setVisibility(View.GONE);
        //Si es nuevo
        }else{
            toggleButtonShow(botonAnadir);
            imagenSubir.setVisibility(View.VISIBLE);
        }

        ocultarTeclado(this.findViewById(android.R.id.content));
    }

    @Override
    public void onClick(View v) {
        Log.i(TAG,"onClick");
        switch (v.getId()){
            case R.id.detalle_botonAnyadir:
                anadirLocalizacion();
                break;
            case R.id.detalle_imagen_subir:
                if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                    Dexter.withActivity(this)
                            .withPermission(android.Manifest.permission.READ_EXTERNAL_STORAGE)
                            .withListener(new PermissionListener() {
                                @Override public void onPermissionGranted(PermissionGrantedResponse response) {/* ... */}
                                @Override public void onPermissionDenied(PermissionDeniedResponse response) {/* ... */}
                                @Override public void onPermissionRationaleShouldBeShown(PermissionRequest permission, PermissionToken token) {/* ... */}
                            }).check();
                }
                if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE)
                        != PackageManager.PERMISSION_GRANTED) {
                    return;
                }

                Intent galleryIntent = new Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                startActivityForResult(galleryIntent, RESULT_LOAD_IMAGE );
                break;
            default:
                break;
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode == RESULT_LOAD_IMAGE && resultCode == RESULT_OK && data != null){
            Uri imagenSelecionada = data.getData();
            imagenSubir.setImageURI(imagenSelecionada);
            String path = getRealPathFromUri(getApplicationContext(), imagenSelecionada);
            imagenSubir.setTag(path);
        }
    }

    private void anadirLocalizacion(){

        Toast nToast1 = Toast.makeText(getApplicationContext(),
               "Añadiendo localizacion", Toast.LENGTH_SHORT);
        nToast1.show();

        String url = getResources().getString(R.string.conf_clocWs_dominio)+
                    getResources().getString(R.string.conf_clocWs_anadirLocalizacion);

        String keyCaptura = null;
        Calendar fechaActual = Calendar.getInstance();
        fechaActual.get(Calendar.YEAR);
        if(!"imagen_vacia".equals(String.valueOf(imagenSubir.getTag()))){
            keyCaptura  = detalle_etTituloVO.getText().toString() + "_" +
                    fechaActual.get(Calendar.YEAR) + fechaActual.get(Calendar.MONTH)+1
                    + fechaActual.get(Calendar.DAY_OF_MONTH)+ "_" + fechaActual.get(Calendar.SECOND)
                    + fechaActual.get(Calendar.MILLISECOND);
        }

        new anadirLocalizacionTask().execute(url,
                                detalle_etTituloVO.getText().toString(), detalle_etTituloESP.getText().toString() ,
                                detalle_etAnyo.getText().toString(), detalle_etDirector.getText().toString(),
                                latitud, longitud,
                                keyCaptura, detalle_etDescripcion.getText().toString(), String.valueOf(imagenSubir.getTag()));

    }

    private class obtenerDetalleTask extends AsyncTask<String, Void, String> {

        String output;
        StringBuilder respuesta = new StringBuilder();

        @Override
        protected void onPreExecute () {
            Log.i(TAG, "onPreExecute obtenerDetalleTask");

        }

        @Override
        protected String doInBackground (String...params){
            Log.i(TAG, "doInBackground obtenerDetalleTask");

            try {
                String metodoGet = params[0];

                URL url = new URL(metodoGet);
                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setRequestMethod("GET");
                conn.setRequestProperty("Accept", "application/json");

                if (conn.getResponseCode() != HttpURLConnection.HTTP_OK) {
                    throw new RuntimeException("Failed : HTTP error code : "
                            + conn.getResponseCode());
                }

                BufferedReader br = new BufferedReader(new InputStreamReader(
                        (conn.getInputStream())));


                while ((output = br.readLine()) != null) {
                    respuesta.append(output);
                }

                conn.disconnect();

            } catch (ProtocolException e) {
                e.printStackTrace();
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return respuesta.toString();
        }

        @Override
        protected void onPostExecute (String respuesta){
            Log.i(TAG, "onPostExecute obtenerDetalleTask");
            Log.i(TAG, respuesta + "");
            try {
                JSONObject jsnobject = new JSONObject(respuesta);
                JSONArray jsonArray = jsnobject.getJSONArray("localizacionDetalle");
                JSONObject localizacionDetalle;
                for (int i = 0; i < jsonArray.length(); i++) {
                    localizacionDetalle = jsonArray.getJSONObject(i);

                    detalle_etTituloVO.setText(localizacionDetalle.getString("tituloVO"));
                    detalle_etTituloESP.setText(localizacionDetalle.getString("tituloESP"));
                    detalle_etAnyo.setText(localizacionDetalle.getString("anyo"));
                    detalle_etDirector.setText(localizacionDetalle.getString("diretor"));

                    detalle_etTituloVO.setFocusable(false);
                    detalle_etTituloESP.setFocusable(false);
                    detalle_etAnyo.setFocusable(false);
                    detalle_etDirector.setFocusable(false);

                    JSONArray escenasPeliculaArray = localizacionDetalle.getJSONArray("escenaDetalleVO");
                    JSONObject escenasPelicula;

                    //primero cargamos la escena que ha selecionado el usuario
                    for (int j = 0; j < escenasPeliculaArray.length(); j++) {
                        escenasPelicula = escenasPeliculaArray.getJSONObject(j);

                        if(escenasPelicula.getString("escenaId").equals(escenaIdGlobal)){
                            new obtenerImagenTask(escenasPelicula.optString ("captura"),
                                    escenasPelicula.optString("descripcion"),
                                    escenasPelicula.getString("escenaId")).execute();
                        }

                    }

                    //despues cargamos el resto de escenas de la misma pelicula
                    for (int j = 0; j < escenasPeliculaArray.length(); j++) {
                        escenasPelicula = escenasPeliculaArray.getJSONObject(j);

                        if(!escenasPelicula.getString("escenaId").equals(escenaIdGlobal)){
                            new obtenerImagenTask(escenasPelicula.optString ("captura"),
                                    escenasPelicula.optString("descripcion"),
                                    escenasPelicula.getString("escenaId")).execute();
                        }
                    }



                    Log.i(TAG, "onPostExecute obtenerDetalleTask Fin");
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
    }

    private class obtenerImagenTask extends AsyncTask<String, Void, Bitmap>{

        String keyCaptura;
        String descripcion;
        String idEscena;

        private obtenerImagenTask(String keyCaptura, String descripcion, String idEscena) {
            this.keyCaptura = keyCaptura;
            this.descripcion = descripcion;
            this.idEscena = idEscena;
        }

        @Override
        protected void onPreExecute() {
            Log.i(TAG, "onPreExecute obtenerImagenTask");
        }

        @Override
        protected Bitmap doInBackground(String... params) {
            Log.i(TAG, "doInBackground obtenerImagenTask");

            //Descargamos la imagen de Amazon S3 si el usuario la habia subido con anterioridad
            if(keyCaptura != null) {
                CognitoCachingCredentialsProvider credentialsProvider = new CognitoCachingCredentialsProvider(
                        getApplicationContext(),
                        getResources().getString(R.string.conf_aws_cognito_identityPool), // Identity Pool ID
                        Regions.EU_CENTRAL_1 // Region
                );

                AmazonS3 s3 = new AmazonS3Client(credentialsProvider);
                System.setProperty(SDKGlobalConfiguration.ENABLE_S3_SIGV4_SYSTEM_PROPERTY, "true");
                System.setProperty(SDKGlobalConfiguration.ENFORCE_S3_SIGV4_SYSTEM_PROPERTY, "true");
                s3.setS3ClientOptions(new S3ClientOptions().withPathStyleAccess(true));
                s3.setRegion(Region.getRegion(Regions.EU_CENTRAL_1));

                TransferUtility transferUtility = new TransferUtility(s3, getApplicationContext());
                S3ObjectInputStream content = s3.getObject(getResources().getString(R.string.conf_aws_bucketName),
                        keyCaptura).getObjectContent();
                byte[] bytes = new byte[0];
                try {
                    bytes = IOUtils.toByteArray(content);
                } catch (IOException e) {
                    e.printStackTrace();
                }
                Bitmap bitmap = BitmapFactory.decodeByteArray(bytes, 0, bytes.length);

                return bitmap;
            }else{
                return null;
            }

        }

        @Override
        protected void onPostExecute(Bitmap bitmap) {
            Log.i(TAG, "onPostExecute obtenerImagenTask");

            ImageView imageView = new ImageView(getApplicationContext());

            imageView.setFocusable(false);
            if(bitmap != null) {

                imageView.setMaxHeight(150);
                imageView.setMaxWidth(200);
                imageView.setImageBitmap(bitmap);

            }else{
                imageView.setImageResource(R.drawable.imagen_vacia);
            }

            if(!escenaIdGlobal.equals(idEscena) && primeraDeOtrasImagen){
                addTextViewOtrasEscenas();
                primeraDeOtrasImagen = false;
            }
            linearLayout.addView(imageView);
            addTextViewDescripcion();
            addEditTextDescripcion(descripcion, false);

        }
    }

    private class anadirLocalizacionTask extends AsyncTask<String, Void, String>{

        String output;
        StringBuilder respuesta = new StringBuilder();

        @Override
        protected void onPreExecute () {
            Log.i(TAG, "onPreExecute anadirLocalizacionTask");
        }

        @Override
        protected String doInBackground (String...params) {
            Log.i(TAG, "doInBackground anadirLocalizacionTask");
            String localizacionDetalleString = "";

            try {

                //Subimos imagen a aws S3 si el usuario a seleccionado una imagen
                if(params[7] != null){
                    CognitoCachingCredentialsProvider credentialsProvider = new CognitoCachingCredentialsProvider(
                            getApplicationContext(),
                            getResources().getString(R.string.conf_aws_cognito_identityPool), // Identity Pool ID
                            Regions.EU_CENTRAL_1 // Region
                    );

                    AmazonS3 s3 = new AmazonS3Client(credentialsProvider);
                    System.setProperty(SDKGlobalConfiguration.ENABLE_S3_SIGV4_SYSTEM_PROPERTY, "true");
                    System.setProperty(SDKGlobalConfiguration.ENFORCE_S3_SIGV4_SYSTEM_PROPERTY, "true");
                    s3.setS3ClientOptions(new S3ClientOptions().withPathStyleAccess(true));
                    s3.setRegion(Region.getRegion(Regions.EU_CENTRAL_1));

                    TransferUtility transferUtility = new TransferUtility(s3, getApplicationContext());
                    String completPath = String.valueOf(params[9]);
                    File myFile = new File(completPath);

                    TransferObserver observerU = transferUtility.upload(
                            getResources().getString(R.string.conf_aws_bucketName),  // The bucket to upload to
                            params[7],     // The key for the uploaded object
                            myFile       // The file where the data to upload exists
                    );
                }

                //Subimos JSON a la base de datos
                String metodoPOST = params[0];

                JSONObject localizacionDetalle = new JSONObject();
                JSONArray escenaDetalleList = new JSONArray();
                JSONObject escenaDetalle = new JSONObject();

                localizacionDetalle.put("tituloVO", params[1]);
                localizacionDetalle.put("tituloESP", params[2]);
                localizacionDetalle.put("anyo", params[3]);
                localizacionDetalle.put("director", params[4]);
                escenaDetalle.put("latitud", params[5]);
                escenaDetalle.put("longitud", params[6]);
                escenaDetalle.put("captura", params[7]);
                escenaDetalle.put("descripcion", params[8]);
                //params[9] path imatge
                escenaDetalleList.put(escenaDetalle);
                localizacionDetalle.put("escenaDetalleList", escenaDetalleList);


                localizacionDetalleString = localizacionDetalle.toString();


                URL url = new URL(metodoPOST);
                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setRequestMethod("POST");
                conn.setRequestProperty("Content-Type", "application/json");

                OutputStream os = conn.getOutputStream();
                os.write(localizacionDetalleString.getBytes());
                os.flush();


                if (conn.getResponseCode() != HttpURLConnection.HTTP_CREATED) {
                    throw new RuntimeException("Failed : HTTP error code : "
                            + conn.getResponseCode());
                }

                BufferedReader br = new BufferedReader(new InputStreamReader(
                        (conn.getInputStream())));


                while ((output = br.readLine()) != null) {
                    respuesta.append(output);
                }

                conn.disconnect();

            } catch (JSONException e) {
                e.printStackTrace();
            } catch (ProtocolException e) {
                e.printStackTrace();
            } catch (MalformedURLException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            return respuesta.toString();

        }


        @Override
        protected void onPostExecute (String a){
            Log.i(TAG, "onPostExecute anadirLocalizacionTask");


            Toast nToast = Toast.makeText(getApplicationContext(),
                    getResources().getString(R.string.detalle_toast_correcto), Toast.LENGTH_SHORT);
            nToast.show();

            toggleButtonShow(botonAnadir);

        }
    }

    private void addTextViewDescripcion(){
        TextView textView = new TextView(this);
        textView.setText(getResources().getText(R.string.detalle_label_descripcion));
        linearLayout.addView(textView);
        ocultarTeclado(this.findViewById(android.R.id.content));
    }

    private void addTextViewOtrasEscenas(){
        TextView textView = new TextView(this);
        textView.setText(getResources().getText(R.string.detalle_label_otras_escena));
        textView.setTextSize(TypedValue.COMPLEX_UNIT_SP, 19);
        linearLayout.addView(textView);
    }

    private void addEditTextDescripcion(String descripcion, boolean editable){
        EditText editText = new EditText(this);
        editText.setText(descripcion);
        if(editable){
            editText.setFocusable(true);
        }else{
            editText.setFocusable(false);
        }

        linearLayout.addView(editText);
    }

    private void toggleButtonShow(Button b){
        if(b.getVisibility() == View.VISIBLE){
            b.setVisibility(View.GONE);
        }else{
            b.setVisibility(View.VISIBLE);
        }
    }

    public static String getRealPathFromUri(Context context, Uri contentUri) {
        Cursor cursor = null;
        try {
            String[] proj = { MediaStore.Images.Media.DATA };
            cursor = context.getContentResolver().query(contentUri, proj, null, null, null);
            int column_index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
            cursor.moveToFirst();
            return cursor.getString(column_index);
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }
    }

    public void ocultarTeclado(View v){
        // Ocultar teclado virtual
        InputMethodManager imm =
                (InputMethodManager) getSystemService(INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(v.getWindowToken(), 0);
    }

}
